﻿using System.Reflection;

namespace NewUpdateDialogSpace
{
    internal static class NewUpdateDialog
    {
        public static bool NewUpdateWindowHasBeenOpened = false;
        public const string ModName = "True Minecraft Swords";
        public const string LastViewedVersionJsonPath = ModName + "_LastViewedVersion.json";

        public static void TryCreateNewUpdateDialog()
        {
            if (NewUpdateWindowHasBeenOpened)
            {
                return;
            }

            string lastVersion = "";
            try
            {
                lastVersion = ModAPI.DeserialiseJSON<string>(LastViewedVersionJsonPath);
            }
            catch
            {
            }

            string thisVersion = ModLoader.LoadedMods.Find((ModMetaData meta) => meta.Name == ModName && meta.Author == "Int Team").ModVersion;
            NewUpdateWindowHasBeenOpened = thisVersion == lastVersion;

            if (NewUpdateWindowHasBeenOpened)
            {
                return;
            }

            DialogBox discordInvite = DialogBoxManager.Dialog("Support the Int Team by watching the trailer and joining our discord community!", new DialogButton[]
            {
                new DialogButton("Trailer", false, () =>
                {
                    OpenLink("https://www.youtube.com/watch?v=taLCIPGiKgM&list=PLvrXKlC-hDr01PI26ApvRxgz2ZIj7gfHJ&index=10&ab_channel=IntTeam");
                }),
                new DialogButton("Discord", false, () =>
                {
                    OpenLink("https://discord.gg/cCQkWJ9j6W");
                }),
                new DialogButton("Close", true)
            });
            NewUpdateWindowHasBeenOpened = true;
            ModAPI.SerialiseJSON(thisVersion, LastViewedVersionJsonPath);
        }
        public static void OpenLink(string url)
        {
            typeof(Utils).GetMethod("OpenURL", BindingFlags.Public | BindingFlags.Static).Invoke(null, new object[1] { url });
        }
    }
}

// Originally uploaded by 'Int Team'. Do not reupload without their explicit permission.
